"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.IDL = void 0;
exports.IDL = {
    "version": "0.1.0",
    "name": "propeasy_program",
    "instructions": [
        {
            "name": "initializePlatform",
            "accounts": [
                {
                    "name": "platformState",
                    "isMut": true,
                    "isSigner": false
                },
                {
                    "name": "admin",
                    "isMut": true,
                    "isSigner": true
                },
                {
                    "name": "purchaseMintAccount",
                    "isMut": false,
                    "isSigner": false
                },
                {
                    "name": "platformMintAccount",
                    "isMut": false,
                    "isSigner": false
                },
                {
                    "name": "systemProgram",
                    "isMut": false,
                    "isSigner": false
                },
                {
                    "name": "rent",
                    "isMut": false,
                    "isSigner": false
                }
            ],
            "args": [
                {
                    "name": "bump",
                    "type": "u8"
                }
            ]
        },
        {
            "name": "createProperty",
            "accounts": [
                {
                    "name": "admin",
                    "isMut": true,
                    "isSigner": true
                },
                {
                    "name": "platformState",
                    "isMut": true,
                    "isSigner": false
                },
                {
                    "name": "propertyState",
                    "isMut": true,
                    "isSigner": false
                },
                {
                    "name": "propertyMintAccount",
                    "isMut": false,
                    "isSigner": false
                },
                {
                    "name": "propertyVaultTokenAccount",
                    "isMut": true,
                    "isSigner": false
                },
                {
                    "name": "platformMintAccount",
                    "isMut": false,
                    "isSigner": false
                },
                {
                    "name": "platformVaultTokenAccount",
                    "isMut": true,
                    "isSigner": false
                },
                {
                    "name": "systemProgram",
                    "isMut": false,
                    "isSigner": false
                },
                {
                    "name": "tokenProgram",
                    "isMut": false,
                    "isSigner": false
                },
                {
                    "name": "associatedTokenProgram",
                    "isMut": false,
                    "isSigner": false
                },
                {
                    "name": "rent",
                    "isMut": false,
                    "isSigner": false
                }
            ],
            "args": [
                {
                    "name": "privateSaleStartTime",
                    "type": "i64"
                },
                {
                    "name": "privateSaleEndTime",
                    "type": "i64"
                },
                {
                    "name": "privateSaleSupplyAmount",
                    "type": "u64"
                },
                {
                    "name": "privateSaleTokenPrice",
                    "type": "u64"
                },
                {
                    "name": "privateSaleMinimumPurchaseAmount",
                    "type": "u64"
                },
                {
                    "name": "privateSaleCommissionAmount",
                    "type": "u64"
                },
                {
                    "name": "privateSaleReferralCommissionAmount",
                    "type": "u64"
                },
                {
                    "name": "privateSaleDiscountPercentage",
                    "type": "u32"
                },
                {
                    "name": "privateSaleTgePercentage",
                    "type": "u32"
                },
                {
                    "name": "privateSaleUnlockPeriod",
                    "type": "i64"
                },
                {
                    "name": "privateSaleUnlockDuration",
                    "type": "i64"
                },
                {
                    "name": "privateSaleMinimumPlatformAmount",
                    "type": "u64"
                },
                {
                    "name": "publicSaleStartTime",
                    "type": "i64"
                },
                {
                    "name": "publicSaleEndTime",
                    "type": "i64"
                },
                {
                    "name": "publicSaleSupplyAmount",
                    "type": "u64"
                },
                {
                    "name": "publicSaleTokenPrice",
                    "type": "u64"
                },
                {
                    "name": "publicSaleMinimumPurchaseAmount",
                    "type": "u64"
                },
                {
                    "name": "publicSaleCommissionAmount",
                    "type": "u64"
                },
                {
                    "name": "publicSaleCommissionBoostAmount",
                    "type": "u64"
                },
                {
                    "name": "publicSaleReferralCommissionAmount",
                    "type": "u64"
                },
                {
                    "name": "publicSaleReferralCommissionBoostAmount",
                    "type": "u64"
                },
                {
                    "name": "publicSaleReferralCommissionBoostThreshold",
                    "type": "u64"
                },
                {
                    "name": "bump",
                    "type": "u8"
                }
            ]
        },
        {
            "name": "purchasePropertyToken",
            "accounts": [
                {
                    "name": "user",
                    "isMut": true,
                    "isSigner": true
                },
                {
                    "name": "platformState",
                    "isMut": false,
                    "isSigner": false
                },
                {
                    "name": "platformMintAccount",
                    "isMut": false,
                    "isSigner": false
                },
                {
                    "name": "userPlatformTokenAccount",
                    "isMut": true,
                    "isSigner": false
                },
                {
                    "name": "platformVaultTokenAccount",
                    "isMut": true,
                    "isSigner": false
                },
                {
                    "name": "admin",
                    "isMut": false,
                    "isSigner": false
                },
                {
                    "name": "adminPurchaseTokenAccount",
                    "isMut": true,
                    "isSigner": false
                },
                {
                    "name": "purchaseMintAccount",
                    "isMut": false,
                    "isSigner": false
                },
                {
                    "name": "userPurchaseTokenAccount",
                    "isMut": true,
                    "isSigner": false
                },
                {
                    "name": "propertyState",
                    "isMut": true,
                    "isSigner": false
                },
                {
                    "name": "propertyMintAccount",
                    "isMut": false,
                    "isSigner": false
                },
                {
                    "name": "userPropertyTokenAccount",
                    "isMut": true,
                    "isSigner": false
                },
                {
                    "name": "propertyVaultTokenAccount",
                    "isMut": true,
                    "isSigner": false
                },
                {
                    "name": "lockerAccount",
                    "isMut": true,
                    "isSigner": false
                },
                {
                    "name": "systemProgram",
                    "isMut": false,
                    "isSigner": false
                },
                {
                    "name": "tokenProgram",
                    "isMut": false,
                    "isSigner": false
                },
                {
                    "name": "associatedTokenProgram",
                    "isMut": false,
                    "isSigner": false
                },
                {
                    "name": "rent",
                    "isMut": false,
                    "isSigner": false
                }
            ],
            "args": [
                {
                    "name": "amount",
                    "type": "u64"
                }
            ]
        },
        {
            "name": "claimPropertyToken",
            "accounts": [
                {
                    "name": "user",
                    "isMut": true,
                    "isSigner": true
                },
                {
                    "name": "propertyState",
                    "isMut": true,
                    "isSigner": false
                },
                {
                    "name": "propertyMintAccount",
                    "isMut": false,
                    "isSigner": false
                },
                {
                    "name": "userPropertyTokenAccount",
                    "isMut": true,
                    "isSigner": false
                },
                {
                    "name": "propertyVaultTokenAccount",
                    "isMut": true,
                    "isSigner": false
                },
                {
                    "name": "lockerAccount",
                    "isMut": true,
                    "isSigner": false
                },
                {
                    "name": "tokenProgram",
                    "isMut": false,
                    "isSigner": false
                }
            ],
            "args": []
        },
        {
            "name": "updateProperty",
            "accounts": [
                {
                    "name": "admin",
                    "isMut": true,
                    "isSigner": true
                },
                {
                    "name": "platformState",
                    "isMut": true,
                    "isSigner": false
                },
                {
                    "name": "propertyState",
                    "isMut": true,
                    "isSigner": false
                },
                {
                    "name": "propertyMintAccount",
                    "isMut": false,
                    "isSigner": false
                }
            ],
            "args": [
                {
                    "name": "privateSaleStartTime",
                    "type": "i64"
                },
                {
                    "name": "privateSaleEndTime",
                    "type": "i64"
                },
                {
                    "name": "privateSaleSupplyAmount",
                    "type": "u64"
                },
                {
                    "name": "privateSaleTokenPrice",
                    "type": "u64"
                },
                {
                    "name": "privateSaleMinimumPurchaseAmount",
                    "type": "u64"
                },
                {
                    "name": "privateSaleCommissionAmount",
                    "type": "u64"
                },
                {
                    "name": "privateSaleReferralCommissionAmount",
                    "type": "u64"
                },
                {
                    "name": "privateSaleDiscountPercentage",
                    "type": "u32"
                },
                {
                    "name": "privateSaleTgePercentage",
                    "type": "u32"
                },
                {
                    "name": "privateSaleUnlockPeriod",
                    "type": "i64"
                },
                {
                    "name": "privateSaleUnlockDuration",
                    "type": "i64"
                },
                {
                    "name": "privateSaleMinimumPlatformAmount",
                    "type": "u64"
                },
                {
                    "name": "publicSaleStartTime",
                    "type": "i64"
                },
                {
                    "name": "publicSaleEndTime",
                    "type": "i64"
                },
                {
                    "name": "publicSaleSupplyAmount",
                    "type": "u64"
                },
                {
                    "name": "publicSaleTokenPrice",
                    "type": "u64"
                },
                {
                    "name": "publicSaleMinimumPurchaseAmount",
                    "type": "u64"
                },
                {
                    "name": "publicSaleCommissionAmount",
                    "type": "u64"
                },
                {
                    "name": "publicSaleCommissionBoostAmount",
                    "type": "u64"
                },
                {
                    "name": "publicSaleReferralCommissionAmount",
                    "type": "u64"
                },
                {
                    "name": "publicSaleReferralCommissionBoostAmount",
                    "type": "u64"
                },
                {
                    "name": "publicSaleReferralCommissionBoostThreshold",
                    "type": "u64"
                }
            ]
        },
        {
            "name": "withdrawToken",
            "accounts": [
                {
                    "name": "admin",
                    "isMut": true,
                    "isSigner": true
                },
                {
                    "name": "platformState",
                    "isMut": true,
                    "isSigner": false
                },
                {
                    "name": "propertyState",
                    "isMut": false,
                    "isSigner": false
                },
                {
                    "name": "propertyMintAccount",
                    "isMut": false,
                    "isSigner": false
                },
                {
                    "name": "withdrawMintAccount",
                    "isMut": false,
                    "isSigner": false
                },
                {
                    "name": "withdrawVaultTokenAccount",
                    "isMut": true,
                    "isSigner": false
                },
                {
                    "name": "adminWithdrawTokenAccount",
                    "isMut": true,
                    "isSigner": false
                },
                {
                    "name": "tokenProgram",
                    "isMut": false,
                    "isSigner": false
                }
            ],
            "args": [
                {
                    "name": "amount",
                    "type": "u64"
                }
            ]
        },
        {
            "name": "changeMintTokenPlatform",
            "accounts": [
                {
                    "name": "admin",
                    "isMut": true,
                    "isSigner": true
                },
                {
                    "name": "platformState",
                    "isMut": true,
                    "isSigner": false
                },
                {
                    "name": "purchaseMintAccount",
                    "isMut": false,
                    "isSigner": false
                },
                {
                    "name": "platformMintAccount",
                    "isMut": false,
                    "isSigner": false
                },
                {
                    "name": "systemProgram",
                    "isMut": false,
                    "isSigner": false
                },
                {
                    "name": "rent",
                    "isMut": false,
                    "isSigner": false
                }
            ],
            "args": []
        }
    ],
    "accounts": [
        {
            "name": "lockerState",
            "type": {
                "kind": "struct",
                "fields": [
                    {
                        "name": "privateSaleClaimedAmount",
                        "type": "u64"
                    },
                    {
                        "name": "privateSaleTotalClaimableAmount",
                        "type": "u64"
                    },
                    {
                        "name": "publicSaleTotalAmount",
                        "type": "u64"
                    }
                ]
            }
        },
        {
            "name": "platformState",
            "type": {
                "kind": "struct",
                "fields": [
                    {
                        "name": "admin",
                        "type": "publicKey"
                    },
                    {
                        "name": "purchaseMintAccount",
                        "type": "publicKey"
                    },
                    {
                        "name": "platformMintAccount",
                        "type": "publicKey"
                    },
                    {
                        "name": "bump",
                        "type": {
                            "array": [
                                "u8",
                                1
                            ]
                        }
                    }
                ]
            }
        },
        {
            "name": "propertyState",
            "type": {
                "kind": "struct",
                "fields": [
                    {
                        "name": "privateSaleInfo",
                        "type": {
                            "defined": "PrivateSaleInfo"
                        }
                    },
                    {
                        "name": "publicSaleInfo",
                        "type": {
                            "defined": "PublicSaleInfo"
                        }
                    },
                    {
                        "name": "propertyMintAccount",
                        "type": "publicKey"
                    },
                    {
                        "name": "bump",
                        "type": {
                            "array": [
                                "u8",
                                1
                            ]
                        }
                    }
                ]
            }
        }
    ],
    "types": [
        {
            "name": "PrivateSaleInfo",
            "type": {
                "kind": "struct",
                "fields": [
                    {
                        "name": "startTime",
                        "type": "i64"
                    },
                    {
                        "name": "endTime",
                        "type": "i64"
                    },
                    {
                        "name": "supplyAmount",
                        "type": "u64"
                    },
                    {
                        "name": "tokenPrice",
                        "type": "u64"
                    },
                    {
                        "name": "minimumPurchaseAmount",
                        "type": "u64"
                    },
                    {
                        "name": "totalPurchasedAmount",
                        "type": "u64"
                    },
                    {
                        "name": "commissionAmount",
                        "type": "u64"
                    },
                    {
                        "name": "referralCommissionAmount",
                        "type": "u64"
                    },
                    {
                        "name": "discountPercentage",
                        "type": "u32"
                    },
                    {
                        "name": "tgePercentage",
                        "type": "u32"
                    },
                    {
                        "name": "unlockPeriod",
                        "type": "i64"
                    },
                    {
                        "name": "unlockDuration",
                        "type": "i64"
                    },
                    {
                        "name": "minimumPlatformAmount",
                        "type": "u64"
                    }
                ]
            }
        },
        {
            "name": "PublicSaleInfo",
            "type": {
                "kind": "struct",
                "fields": [
                    {
                        "name": "startTime",
                        "type": "i64"
                    },
                    {
                        "name": "endTime",
                        "type": "i64"
                    },
                    {
                        "name": "supplyAmount",
                        "type": "u64"
                    },
                    {
                        "name": "tokenPrice",
                        "type": "u64"
                    },
                    {
                        "name": "minimumPurchaseAmount",
                        "type": "u64"
                    },
                    {
                        "name": "totalPurchasedAmount",
                        "type": "u64"
                    },
                    {
                        "name": "commissionAmount",
                        "type": "u64"
                    },
                    {
                        "name": "commissionBoostAmount",
                        "type": "u64"
                    },
                    {
                        "name": "referralCommissionAmount",
                        "type": "u64"
                    },
                    {
                        "name": "referralCommissionBoostAmount",
                        "type": "u64"
                    },
                    {
                        "name": "referralCommissionBoostThreshold",
                        "type": "u64"
                    }
                ]
            }
        },
        {
            "name": "ErrorCode",
            "type": {
                "kind": "enum",
                "variants": [
                    {
                        "name": "InvalidTime"
                    },
                    {
                        "name": "ExceedTokenSupply"
                    },
                    {
                        "name": "InvalidPurchaseTime"
                    },
                    {
                        "name": "ExceedSupplyAmount"
                    },
                    {
                        "name": "PlatformTokenAccountNotExist"
                    },
                    {
                        "name": "NotReachMinimumAmount"
                    },
                    {
                        "name": "NotEnoughPlatformToken"
                    },
                    {
                        "name": "MismatchPublickey"
                    },
                    {
                        "name": "ZeroClaimableAmount"
                    },
                    {
                        "name": "NotEnoughBalance"
                    }
                ]
            }
        },
        {
            "name": "SaleType",
            "type": {
                "kind": "enum",
                "variants": [
                    {
                        "name": "PrivateSale"
                    },
                    {
                        "name": "PublicSale"
                    }
                ]
            }
        }
    ],
    "events": [
        {
            "name": "PropertyCreated",
            "fields": [
                {
                    "name": "propertyState",
                    "type": "publicKey",
                    "index": false
                },
                {
                    "name": "propertyMintAccount",
                    "type": "publicKey",
                    "index": false
                }
            ]
        },
        {
            "name": "TokenPurchased",
            "fields": [
                {
                    "name": "user",
                    "type": "publicKey",
                    "index": false
                },
                {
                    "name": "propertyState",
                    "type": "publicKey",
                    "index": false
                },
                {
                    "name": "propertyMintAccount",
                    "type": "publicKey",
                    "index": false
                },
                {
                    "name": "tokenPrice",
                    "type": "u64",
                    "index": false
                },
                {
                    "name": "saleType",
                    "type": "u8",
                    "index": false
                },
                {
                    "name": "purchasedAmount",
                    "type": "u64",
                    "index": false
                },
                {
                    "name": "propertyAmount",
                    "type": "u64",
                    "index": false
                },
                {
                    "name": "purchasedTimestamp",
                    "type": "u64",
                    "index": false
                },
                {
                    "name": "referrer",
                    "type": {
                        "option": "publicKey"
                    },
                    "index": false
                },
                {
                    "name": "individualCommissionAmount",
                    "type": "u64",
                    "index": false
                }
            ]
        },
        {
            "name": "TokenClaimed",
            "fields": [
                {
                    "name": "user",
                    "type": "publicKey",
                    "index": false
                },
                {
                    "name": "propertyState",
                    "type": "publicKey",
                    "index": false
                },
                {
                    "name": "propertyMintAccount",
                    "type": "publicKey",
                    "index": false
                },
                {
                    "name": "claimedAmount",
                    "type": "u64",
                    "index": false
                },
                {
                    "name": "claimedTimestamp",
                    "type": "u64",
                    "index": false
                }
            ]
        }
    ]
};
